/* ************************************************************************** */
/*                                                                            */
/*                                                        :::      ::::::::   */
/*   dancing_links.c                                    :+:      :+:    :+:   */
/*                                                    +:+ +:+         +:+     */
/*   By: gtertysh <marvin@42.fr>                    +#+  +:+       +#+        */
/*                                                +#+#+#+#+#+   +#+           */
/*   Created: 2016/12/20 19:21:42 by gtertysh          #+#    #+#             */
/*   Updated: 2016/12/26 14:41:17 by gtertysh         ###   ########.fr       */
/*                                                                            */
/* ************************************************************************** */

#include "fillit.h"

void	fill_map(char *map, int size, t_node *ttr, int letter)
{
	int		i;
	char	a;

	a = 'A' + letter - 1;
	i = 0;
	while (i < 4)
	{
		ft_memcpy((map + (ttr->coord.y + g_templates[ttr->type].c[i].y) * size +
				ttr->coord.x + g_templates[ttr->type].c[i].x), &a, 1);
		i++;
	}
}

void	print_square(t_node **solution, int amount, int size)
{
	char	*map;
	int		map_size;
	int		i;

	map_size = size * size + 1;
	map = malloc(sizeof(char) * map_size);
	map[map_size] = 0;
	i = 0;
	while (i++ < amount)
		fill_map(map, size, solution[i - 1], i);
	i = 0;
	while (i < map_size - 1)
	{
		if (map[i] >= 'A' && map[i] <= 'Z')
			ft_putchar(map[i]);
		else
			ft_putchar('.');
		if ((i + 1) % size == 0)
			ft_putchar('\n');
		i++;
	}
	exit(0);
}

int		cover(t_node *to_cover)
{
	static	t_node	*step_vert;
	static	t_node	*step_horiz;

	to_cover->left->right = to_cover->right;
	to_cover->right->left = to_cover->left;
	step_vert = to_cover->down;
	while (step_vert != to_cover)
	{
		step_horiz = step_vert->right;
		while (step_horiz != step_vert)
		{
			step_horiz->down->up = step_horiz->up;
			step_horiz->up->down = step_horiz->down;
			step_horiz = step_horiz->right;
		}
		step_vert = step_vert->down;
	}
	return (1);
}

int		uncover(t_node *to_uncover)
{
	static	t_node	*step_vert;
	static	t_node	*step_horiz;

	step_vert = to_uncover->up;
	while (step_vert != to_uncover)
	{
		step_horiz = step_vert->left;
		while (step_horiz != step_vert)
		{
			step_horiz->down->up = step_horiz;
			step_horiz->up->down = step_horiz;
			step_horiz = step_horiz->left;
		}
		step_vert = step_vert->up;
	}
	to_uncover->left->right = to_uncover;
	to_uncover->right->left = to_uncover;
	return (1);
}

void	search(t_node *root, t_node **solution, int k, int amount)
{
	t_node	*current_col;
	t_node	*row;
	t_node	*j;

	if (k == amount)
		print_square(solution, amount, root->size);
	current_col = root->right;
	cover(current_col);
	row = current_col->down;
	while (row != current_col)
	{
		solution[k] = row;
		j = row->right;
		while (j != row && cover(j->column))
			j = j->right;
		search(root, solution, k + 1, amount);
		j = row->left;
		while (j != row && uncover(j->column))
			j = j->left;
		row = row->down;
	}
	uncover(current_col);
	return ;
}
