/* ************************************************************************** */
/*                                                                            */
/*                                                        :::      ::::::::   */
/*   dancing_links_initialization.c                     :+:      :+:    :+:   */
/*                                                    +:+ +:+         +:+     */
/*   By: gtertysh <marvin@42.fr>                    +#+  +:+       +#+        */
/*                                                +#+#+#+#+#+   +#+           */
/*   Created: 2016/12/26 14:40:31 by gtertysh          #+#    #+#             */
/*   Updated: 2016/12/26 14:40:34 by gtertysh         ###   ########.fr       */
/*                                                                            */
/* ************************************************************************** */

#include "fillit.h"

t_node	*init_root(int size)
{
	t_node	*new;

	new = (t_node*)malloc(sizeof(t_node));
	new->left = new;
	new->right = new;
	new->down = new;
	new->up = new;
	new->column = NULL;
	new->size = size;
	return (new);
}

t_node	*add_column(t_node *root)
{
	t_node	*new_col;

	new_col = (t_node*)malloc(sizeof(t_node));
	new_col->down = new_col;
	new_col->up = new_col;
	new_col->left = root->left;
	new_col->right = root;
	root->left->right = new_col;
	root->left = new_col;
	new_col->column = NULL;
	return (new_col);
}

t_node	*add_node_with_coord(t_node *col, t_coord coord, int type)
{
	t_node	*new_node;

	new_node = (t_node*)malloc(sizeof(t_node));
	new_node->coord = coord;
	new_node->type = type;
	new_node->column = col;
	new_node->up = col->up;
	new_node->down = col;
	col->up->down = new_node;
	col->up = new_node;
	return (new_node);
}

t_node	*add_node(t_node *col)
{
	t_node	*new_node;

	new_node = (t_node*)malloc(sizeof(t_node));
	new_node->column = col;
	new_node->up = col->up;
	new_node->down = col;
	col->up->down = new_node;
	col->up = new_node;
	return (new_node);
}

t_node	**add_cols(t_node *root, int number)
{
	t_node	**array;
	int		i;

	array = (t_node**)malloc(number * sizeof(t_node*));
	i = 0;
	while (i < number)
		array[i++] = add_column(root);
	return (array);
}
